<script>
import { efficiencyGain, totalCostSavings } from '../../lib/roiCalculate';
export default {
  props: {
    formData: {
      type: Object,
      required: true,
    },
    timeResults: {
      type: Object,
      required: false,
      default: null,
    },
    premiumFeatures: {
      type: Object,
      required: false,
      default: null,
    },
    ultimateFeatures: {
      type: Object,
      required: false,
      default: null,
    },
  },
  computed: {
    isMobile() {
      return this.width <= 1024;
    },
    numberOfProjects() {
      return this.formData.numberOfUsers / 4;
    },
    toolMaintenancePerProjectHours() {
      // Tool & Security time/project (in hours)
      return (
        this.formData.developmentConfigurationHours *
        (this.formData.daysToProduction / 4)
      );
    },
    toolSecTimePerProjectHours() {
      // Tool & Security time/project (in hours)
      return (
        this.formData.developmentSecurityHours *
        (this.formData.daysToProduction / 4)
      );
    },
    cycleTimePerProjectHours() {
      return this.formData.daysToProduction * 8;
    },
    hoursSpentOnProjectOps() {
      return Math.ceil(
        this.toolMaintenancePerProjectHours + this.cycleTimePerProjectHours,
      );
    },
    hoursSpentOnProjectOpsSec() {
      return Math.ceil(
        this.toolSecTimePerProjectHours +
          this.cycleTimePerProjectHours +
          this.toolMaintenancePerProjectHours,
      );
    },
    toolMaintanenceSavingsPerProjectHours() {
      return (
        this.formData.developmentConfigurationHours *
        0.44 *
        (this.formData.daysToProduction / 4)
      );
    },
    toolSecSavingsPerProjectHours() {
      return (
        this.formData.developmentSecurityHours *
        0.4 *
        (this.formData.daysToProduction / 4)
      );
    },
    cycleTimeSavingsPerProjectHours() {
      return this.formData.daysToProduction * 0.615 * 8;
    },
    hoursSavedPerProjectOps() {
      return Math.ceil(
        this.toolMaintanenceSavingsPerProjectHours +
          this.toolSecTimePerProjectHours +
          this.cycleTimeSavingsPerProjectHours,
      );
    },
    hoursSavedPerProjectOpsSec() {
      return Math.ceil(
        this.toolMaintanenceSavingsPerProjectHours +
          this.toolSecSavingsPerProjectHours +
          this.cycleTimeSavingsPerProjectHours,
      );
    },
    efficiencyUltimate() {
      return efficiencyGain(
        this.hoursSpentOnProjectOpsSec,
        this.hoursSavedPerProjectOpsSec,
      );
    },
    efficiencyPremium() {
      return efficiencyGain(
        this.hoursSpentOnProjectOps,
        this.hoursSavedPerProjectOps,
      );
    },
    totalTimeLostUltimate() {
      return this.hoursSpentOnProjectOpsSec - this.hoursSavedPerProjectOpsSec;
    },
    totalTimeLostPremium() {
      return this.hoursSpentOnProjectOps - this.hoursSavedPerProjectOps;
    },
    totalSavings() {
      return totalCostSavings(this.hoursSavedPerProject, this.numberOfProjects);
    },
  },
};
</script>

<template>
  <div>
    <div class="slp-mb-32 time-results__header">
      <SlpTypography tag="div" variant="heading5-bold">
        {{ timeResults.toolchain_cost }}</SlpTypography
      >
      <SlpTypography tag="h3" variant="heading2-bold">
        <span class="time-results__accent">
          {{
            hoursSpentOnProjectOpsSec
              .toString()
              .replace(/\B(?=(\d{3})+(?!\d))/g, ',')
          }}
          {{ timeResults.hoursPerProject }}</span
        >
      </SlpTypography>
    </div>
    <div class="time-results__block time-results__block--gradient">
      <div>
        <div class="slp-mb-16">
          <SlpTypography tag="div" variant="body1" class="slp-mb-8">
            {{ timeResults.switching }}
          </SlpTypography>
          <SlpTypography tag="div" variant="heading5-bold">
            {{ timeResults.ultimate }}
          </SlpTypography>
        </div>
        <div class="time-results__stats">
          <div>
            <div class="slp-flex">
              <SlpTypography tag="div" variant="body3">
                {{ timeResults.save }}
              </SlpTypography>
              <SlpTooltip
                id="saveUltimate"
                :text="timeResults.tooltip"
                position="top"
                mode="click"
                class="time-results__tooltip"
                data-ga-name="info saveUltimate"
                data-ga-location="time-tab step 3"
              >
                <SlpIcon variant="product" name="information-o"
              /></SlpTooltip>
            </div>

            <SlpTypography tag="div" variant="heading4-bold">
              {{ totalTimeLostUltimate }} {{ timeResults.hours }}
            </SlpTypography>
          </div>
          <div class="time-results__efficiency">
            <SlpTypography tag="div" variant="body3">
              {{ timeResults.efficiency }}
            </SlpTypography>
            <SlpTypography tag="div" variant="heading4-bold">
              {{ efficiencyUltimate }} %
            </SlpTypography>
          </div>
        </div>
      </div>
      <div class="time-results__cta">
        <SlpButton
          class="slp-mb-16"
          :href="timeResults.ultimateButton.href"
          :variant="timeResults.ultimateButton.variant"
          :data-ga-name="timeResults.ultimateButton.data_ga_name"
          :data-ga-location="timeResults.ultimateButton.data_ga_location"
        >
          {{ timeResults.ultimateButton.text }}
        </SlpButton>
        <SlpButton
          :href="timeResults.salesButton.href"
          :variant="timeResults.salesButton.variant"
          :data-ga-name="timeResults.salesButton.data_ga_name"
          :data-ga-location="timeResults.salesButton.data_ga_location"
        >
          {{ timeResults.salesButton.text }}
          <SlpIcon name="chevron-lg-right" variant="product" />
        </SlpButton>
      </div>
    </div>
    <div class="time-results__block">
      <div>
        <div class="slp-mb-16">
          <SlpTypography tag="div" variant="body1" class="slp-mb-8">
            {{ timeResults.switching }}
          </SlpTypography>
          <SlpTypography tag="div" variant="heading5-bold">
            {{ timeResults.premium }}
          </SlpTypography>
        </div>
        <div class="time-results__stats">
          <div>
            <div class="slp-flex">
              <SlpTypography tag="div" variant="body3">
                {{ timeResults.save }}
              </SlpTypography>
              <SlpTooltip
                id="savePremium"
                :text="timeResults.tooltip"
                position="top"
                mode="click"
                class="time-results__tooltip"
                data-ga-name="info savePremium"
                data-ga-location="time-tab step 3"
              >
                <SlpIcon variant="product" name="information-o"
              /></SlpTooltip>
            </div>

            <SlpTypography tag="div" variant="heading4-bold">
              {{ totalTimeLostPremium }} {{ timeResults.hours }}
            </SlpTypography>
          </div>
          <div class="time-results__efficiency">
            <SlpTypography tag="div" variant="body3">
              {{ timeResults.efficiency }}
            </SlpTypography>
            <SlpTypography tag="div" variant="heading4-bold">
              {{ efficiencyPremium }} %
            </SlpTypography>
          </div>
        </div>
      </div>
      <div class="time-results__cta">
        <SlpButton
          class="slp-mb-16"
          :href="timeResults.premiumButton.href"
          :variant="timeResults.premiumButton.variant"
          :data-ga-name="timeResults.premiumButton.data_ga_name"
          :data-ga-location="timeResults.premiumButton.data_ga_location"
        >
          {{ timeResults.premiumButton.text }}
        </SlpButton>
      </div>
    </div>
    <div class="cta-block">
      <SlpTypography
        tag="p"
        variant="body3"
        class="slp-mt-24 description slp-mb-8"
      >
        {{ timeResults.results }}
      </SlpTypography>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.stats {
  display: flex;
  justify-content: space-between;
  gap: 0 $spacing-32;
  align-items: center;
  text-align: left;
  margin-bottom: $spacing-32;

  .accent {
    color: $color-text-link-100;
  }

  &__box {
    background: $color-surface-100;
    padding: $spacing-32 $spacing-24;
    flex: 1 0 45%;

    span {
      display: block;
    }
  }

  @media (max-width: $breakpoint-md) {
    text-align: center;
    flex-wrap: wrap;

    h3 {
      margin-bottom: $spacing-16;
    }

    &__box {
      text-align: left;
    }
  }
}

.description {
  color: $color-text-200;
  text-align: left;
}

.cta-block {
  margin-top: $spacing-24;

  @media (max-width: $breakpoint-md) {
    text-align: left;
  }
}

.flex {
  display: flex;
  align-items: center;

  .slp-tooltip {
    border: none;
  }
}

.time-results {
  &__block {
    background-color: $color-surface-900;
    padding: $spacing-32;
    text-align: left;
    margin: 0px -16px $spacing-24;
    justify-content: space-between;
    border-radius: 4px;
    &--gradient {
      border: 1px solid $color-surface-900;
      background: url(/nuxt-images/calculator/gradient-for-ultimate-tier.png);
      background-repeat: no-repeat;
      background-size: 100% 100%;
    }

    @media (min-width: $breakpoint-md) {
      display: flex;
      margin: 0 0 $spacing-24;
    }
  }
  &__cta {
    flex: 0 0 220px;
    max-width: 220px;
    margin-top: $spacing-32;
    margin-left: 0;
    @media (min-width: $breakpoint-md) {
      margin-top: 0;
      margin-left: $spacing-16;
    }
  }
  &__stats {
    @media (min-width: $breakpoint-md) {
      display: flex;
    }
  }
  &__efficiency {
    margin-top: $spacing-16;
    @media (min-width: $breakpoint-md) {
      margin-left: $spacing-32;
      margin-top: 0;
    }
    @media (min-width: $breakpoint-lg) {
      margin-left: 40px;
    }
  }
  &__accent {
    color: $color-text-link-100;
  }

  &__header {
    text-align: left;
  }

  &__tooltip {
    background: transparent;
    border: none;
    padding: 0;
    margin-left: $spacing-8;
    margin-bottom: $spacing-8;
  }
}
</style>
